<template>
  <div v-if="isOTPEnabled()" class="w-full">
    <el-form-item :prop="phoneProperty" :class="[getChinaTheme ? 'input__container bg-transparent' : '', { required: true }]" :label="getChinaTheme ? '' : label" class="!block !mb-4">
      <div class="flex w-full otp-field items-start" :class= "{'mobile' : isMobile}">
        <div :class="['relative cursor-pointer bg-[var(--background1)]', getChinaTheme ? 'w-[43%] line' : '']">
          <el-select
            ref="countrySelectRef"
            v-model="model.CountryCode"
            class="chinna-country-selector"
            :disabled="nextRequestInSeconds > 0"
            filterable
            :class="getChinaTheme ? 'china round-left' : 'country-select z-[2]'"
            :clearable="false"
            :popper-class="getChinaTheme ? 'before' : 'country-list'"
            placeholder=" "
            id="registerCountry"
          >
            <template v-if="getChinaTheme" #prefix>
              <div class="line px-3.5">
                <font-awesome-icon icon="phone" />
              </div>
            </template>
            <el-option
              v-for="country in countryList"
              :value="country.countryShortCode"
            >
              <div class="flex items-center gap-3">
                <img 
                  class="w-[22px] h-4 rounded-[3px]"
                  :src="commonHelper.getAssetImage(`/assets/country-flag-svgs/${country.countryShortCode?.toLowerCase()}.svg`)"
                  alt="">
                <div class="block max-w-[120px] truncate">
                  {{ country.countryName }}
                </div>
              </div>
            </el-option>
          </el-select>
          <div v-if="model.CountryCode"
            :class="['absolute z-0', getChinaTheme ? 'w-6 h-6 overflow-hidden circle left-[50px] top-[7px]' : 'w-[22px] left-2 h-4 top-[5px]']">
            <img
              :src="commonHelper.getAssetImage(`/assets/country-flag-svgs/${selectedCountry()?.countryShortCode?.toLowerCase()}.svg`)"
              alt=""
              :style="getChinaTheme ? 'transform: scale(1.5)' : ''"
            >
          </div>
        </div>
        <el-input :class="getChinaTheme ? 'round-right' : ''" v-model="model[phoneProperty]" :placeholder="getChinaTheme ? $t('phone') : $t('Phone numbers')" :disabled="nextRequestInSeconds > 0" :formatter="(value: string) => value" :parser="(value: string) => value.replace(/\D+/g, '')" id="registerPhoneNumber">
          <template v-if="!getChinaTheme" #suffix>
            <el-tooltip class="box-item" effect="dark"
              :content="$t('valid_mobile_number_is_required_for_deposit_and_withdrawal_verification_purposes')"
              placement="bottom">
              <el-icon class="el-input__icon" color="var(--primary)">
                <info-filled />
              </el-icon>
            </el-tooltip>
          </template>
        </el-input>
        <el-button v-if="!getChinaTheme" class="!rounded-l-none !px-2" type="primary" :disabled="!model.Phone || !model.CountryCode" :loading="nextRequestInSeconds > 0 || loading" @click="onGetVerificationClicked">
          {{ nextRequestInSeconds ? `(${nextRequestInSeconds})` : $t('Get OTP') }}
        </el-button>
      </div>
    </el-form-item>
    <el-form-item :class="[getChinaTheme ? 'input__container bg-transparent round-right' : '', { required: true }]" prop="OtpVerification">
      <div class="flex w-full">
        <el-input :class="getChinaTheme ? 'round-left' : ''" v-model="model.OtpVerification" :placeholder="$t('OTP code verification')" id="registerOTPVerificationCode"></el-input>
        <el-button v-if="getChinaTheme" class="!rounded-l-none !px-2 bg-gradient round-right" type="primary" :disabled="!model.Phone || !model.CountryCode" :loading="nextRequestInSeconds > 0 || loading" @click="onGetVerificationClicked">
          {{ nextRequestInSeconds ? `(${nextRequestInSeconds})` : $t('Get OTP') }}
        </el-button>
      </div>
    </el-form-item>
  </div>
  <slot v-else name="phone">
    <el-form-item :prop="phoneProperty" :class="{ required: isRequired }" :label="label" class="!block">
      <el-input v-model="model[phoneProperty]" :placeholder="$t('Phone numbers')" :formatter="(value: string) => value" :parser="(value: string) => value.replace(/\D+/g, '')" id="registerPhoneNumber">
        <template #suffix>
          <el-tooltip class="box-item" effect="dark"
            :content="$t('valid_mobile_number_is_required_for_deposit_and_withdrawal_verification_purposes')"
            placement="bottom">
            <el-icon class="el-input__icon" color="var(--primary)">
              <info-filled />
            </el-icon>
          </el-tooltip>
        </template>
      </el-input>
    </el-form-item>
  </slot>
</template>

<script setup lang="ts">
import { CountryList, countryList } from '@/utils/countries';
import { IFormModel, isOTPEnabled } from '@/composables/useRegister';
import commonHelper from '~~/utils/commonHelper';
import { store } from '~~/store';

const isMobile = useDevice().isMobile;
const emit = defineEmits(['update:modelValue', 'get-code']);
const props = defineProps<{
  modelValue: IFormModel;
  phoneProperty: keyof IFormModel;
  nextRequestInSeconds: number;
  label?: string;
  isRequired?: boolean;
  loading?: boolean;
}>();
const countrySelectRef = ref();
const model = computed({
  get: () => {
    return props.modelValue
  },
  set: (value) => emit('update:modelValue', value),
})
const selectedCountry = () => (countryList.find((v) => v.countryShortCode === model.value.CountryCode) || {}) as CountryList;
const defaultCountry = computed(() => store.state.geography?.CountryCode)
watch(
  () => defaultCountry.value,
  (v) => {
    if (!model.value.CountryCode && v) {
      model.value.CountryCode = v;
    } else if (!model.value.CountryCode && !v) {
      model.value.CountryCode = countryList[0].countryShortCode;
    }
  },
  {
    immediate: true,
  }
)
watch(
  () => model.value.CountryCode,
  () => {
    const { phoneNumberCode = 0 } = selectedCountry();
    model.value.PhoneNumberCode = phoneNumberCode;
  },
  { immediate: true }
)
const onGetVerificationClicked = () => {
  if (!model.value.Phone || !model.value.CountryCode) return;
  emit('get-code');
}
const getChinaTheme = store.state.selectedThemeName === 'china';
</script>

<style lang="scss">
.otp-field.mobile > .el-input > .el-input__wrapper > input {
  height: 48px !important;
  border-radius: 0px;
}
.otp-field.mobile > .el-button {
  height: 48px !important;
}
.otp-field.mobile > .cursor-pointer {
  height: 48px;
}
.otp-field.mobile > .cursor-pointer > .country-select {
  height: 48px;
}
.otp-field.mobile > .cursor-pointer :nth-child(2) {
  top: 12px;
}
.otp-field.mobile > .cursor-pointer .el-input__suffix {
  top: 0;
}
.otp-field.mobile > .cursor-pointer .china .line {
  height: 100%;
  display: flex;
  align-items: center;
}
.input__container.bg-transparent .otp-field.mobile > .cursor-pointer.line {
  height: 52px;
}
[layout="modern"], [layout="peru"] {
  .otp-field.mobile {
    .cursor-pointer {
      height: 40px;
      .country-select {
      height: 40px;
      }
    }
    .el-input {
      .el-input__wrapper {
        input {
          height: 40px !important;
        }
      }
    }
    .el-button {
      height: 40px !important;
    }
  }
}
.otp-field {
  .el-input {
    --el-input-border-radius: 0;
  }
}
</style>

<style>
.bg-gradient {
  background: linear-gradient(90deg, #62B3FF 0%, #4176FA 100%) !important;
  border: 0;
  height: auto;
  opacity: 1;
}
.round-right {
  border-radius: 0px 20px 20px 0px !important;
}
.el-select.china .el-input, .round-left {
  border-radius: 20px 0 0 20px !important;
}
.before.el-popper.is-light .el-popper__arrow::before {
    right: -22px;
}
.circle {
  border-radius: 100%;
}
.el-input__inner::placeholder {
  display: none;
}

.el-input__inner::-ms-input-placeholder {
  display: none;
}
.el-select.china i.el-icon.el-select__caret.el-select__icon, .el-select.china .el-select .el-select .el-input .el-select__caret.is-reverse {
  color: #fff;
  right: -8px;
  width: 10px;
}
.el-select.china .el-input__inner {
  visibility: hidden;
}
</style>

<style scoped lang="scss">
:deep(.el-select-dropdown.country-list .el-select-dropdown__item) {
  padding-left: 6px;
}

:deep(.chinna-country-selector) {
  .el-input__suffix {
    .el-input__icon:not(.el-icon.el-select__caret) {
      display: none;
    }
  }
}

:deep(.el-select.country-select) {
  width: 58px;
  height: 32px;
  box-shadow: 0 0 0 1px #dcdfe6 inset;
  box-shadow: 0 0 0 1px var(--border, var(--el-border-color)) inset;
  border-radius: 4px 0px 0px 4px;
  .el-input__suffix {
    right: 8px;
    .el-input__icon:not(.el-icon.el-select__caret) {
      display: none;
    }
    
    .el-icon.el-select__caret {
      width: 12px;
    } 
  }
  .el-input__inner {
    visibility: hidden;
  }
}
.line {
  border-right: 1px solid #fff;
}
.el-icon.el-input__icon {
  width: 16px;
  svg {
    width: 16px;
    height: 16px;
  }
}
</style>